fLoadTexture proto hBmp:dword,Wrap:dword
fGetMatrix4f proto lpfMat4:dword,nIndex:dword
fFillMatrix4f proto lpfMat4:dword,nIndex:dword,lpValueReal4:dword

fMat4 struct
	data real4 16 dup (0.0)
fMat4 ends

fVec struct
	i real4 0.0
	j real4 0.0
	k real4 0.0
fVec ends

.data
;	m fMat4 <?>
	mat_arr real4 0 dup (16)
	
	m_MaxPitchRate			dd 5.0f
	m_MaxHeadingRate		dd 5.0f
	m_HeadingDegrees		dd 0.0f
	m_PitchDegrees			dd 0.0f
	m_MaxForwardVelocity	dd 5.0f
	m_ForwardVelocity		dd 0.0f
	direction_v				fVec <0.0f>
	ex_posX					dd 0.0f
	ex_posY					dd 0.0f
	ex_posZ					dd 0.0f
.code

glPrint proc uses esi lpText:dword,lpFltX:dword,lpFltY:dword
	
	invoke glPushMatrix
	invoke glMatrixMode,GL_MODELVIEW
	invoke glLoadIdentity
	invoke glPushAttrib,GL_LIST_BIT
	invoke glRasterPos2f,lpFltX,lpFltY
	mov eax,base
	sub eax,32
	invoke glListBase,eax
	invoke lstrlen,lpText
	mov edx,eax
	invoke glCallLists,edx,GL_UNSIGNED_BYTE,lpText
	invoke glPopAttrib
	invoke glPopMatrix
	
	ret
glPrint endp

;---------------------------------------
; Originally written by  Vic Hollis

fSetPitch proc uses esi edi lpfDegree:dword
	LOCAL d,mxd:dword
	
	fld lpfDegree
	fistp d
	
	fld m_MaxPitchRate
	fistp mxd
	
	mov eax,d
	cmp eax,mxd
	jg here
		fld m_PitchDegrees
		fadd lpfDegree
		jmp @1
	here:
		cmp eax,0
		jg @f
			fld m_PitchDegrees
			fsub m_MaxPitchRate
			fstp m_PitchDegrees
			jmp @1
		@@:
			fld m_PitchDegrees
			fadd m_MaxPitchRate
			fstp m_PitchDegrees
		@1:
	
	
	fld m_MaxPitchRate
	fistp mxd
	
	cmp mxd,360
	jl @f
		fld m_PitchDegrees
		fsub CFLT(360.0)
		fstp m_PitchDegrees
		ret
	@@:
		fld m_PitchDegrees
		fadd CFLT(360.0)
		fstp m_PitchDegrees
	
	
	ret
fSetPitch endp

fSetPerspective proc uses esi edi
	LOCAL matrix[16]:real4
	LOCAL _ex,_ey,_ez:dword
	
	invoke glRotatef,m_HeadingDegrees, CFLT(0.0f), CFLT(1.0f), CFLT(0.0f)
	invoke glRotatef,m_PitchDegrees, CFLT(1.0f), CFLT(0.0f), CFLT(0.0f)
	
	invoke glGetFloatv,GL_MODELVIEW_MATRIX,addr matrix
	
	lea esi,matrix
	fld dword ptr[esi+8*4]
	fstp direction_v.i
	
	fld dword ptr[esi+10*4]
	fstp direction_v.k
	
;	invoke glLoadIdentity
	
	invoke glRotatef,m_PitchDegrees, CFLT(1.0f), CFLT(0.0f), CFLT(0.0f)
	invoke glGetFloatv,GL_MODELVIEW_MATRIX,addr matrix
	
	fld dword ptr [esi+9*4]
	fstp direction_v.j
	
	invoke glRotatef,m_HeadingDegrees, CFLT(0.0f), CFLT(1.0f), CFLT(0.0f)
	
	fld direction_v.i
	fmul m_ForwardVelocity
	fstp direction_v.i
	
	fld direction_v.j
	fmul m_ForwardVelocity
	fstp direction_v.j
	
	fld direction_v.k
	fmul m_ForwardVelocity
	fstp direction_v.k
	
	fld ex_posX
	fadd direction_v.i
	fst ex_posX
	fchs 
	fstp _ex
	
	fld ex_posY
	fadd direction_v.j
	fst ex_posY
	fchs 
	fstp _ey
	
	fld ex_posZ
	fadd direction_v.k
	fst ex_posZ
	fstp _ez
	
	invoke glTranslatef,_ex,_ey,_ez
	
	
	ret
fSetPerspective endp

;-------------------------------------------

; ------------------------------------------------------------------------------------------------
; Originally wrote by Alexander Festini
; Status: Not Completed
fSetCamera proc uses esi lpX:dword,lpY:dword,lpZ:dword
	
	invoke memfill,addr mat_arr,64,0
	lea esi,mat_arr
	
	fld1
	fstp dword ptr [esi+0*4]
	fld1
	fstp dword ptr[esi+5*4]
	fld1
	fchs
	fstp dword ptr[esi+10*4]
	fld1
	fstp dword ptr[esi+15*4]
	
	fld lpX
	fstp dword ptr[esi+12*4]
	fld lpY
	fstp dword ptr[esi+13*4]
	fld lpZ
	fstp dword ptr[esi+14*4]
	
	
	ret
fSetCamera endp

fSetView proc uses esi edi
	LOCAL v_mat[16]:dword
	LOCAL tmp:dword
	
	lea esi,mat_arr
	invoke glMatrixMode,GL_MODELVIEW
	invoke glLoadIdentity
	
	invoke memfill,addr v_mat,64,0
	
	lea edi,v_mat
	fld dword ptr[esi+0*4]
	fstp dword ptr [edi+0*4]
	fld dword ptr [esi+4*4]
	fstp dword ptr [edi+1*4]
	fld dword ptr [esi+8*4]
	fchs
	fstp dword ptr [edi+2*4]
	fldz
	fstp dword ptr [edi+3*4]
	
	fld dword ptr[esi+1*4]
	fstp dword ptr [edi+4*4]
	fld dword ptr [esi+5*4]
	fstp dword ptr [edi+5*4]
	fld dword ptr [esi+9*4]
	fchs
	fstp dword ptr [edi+6*4]
	fldz
	fstp dword ptr [edi+7*4]

	fld dword ptr[esi+2*4]
	fstp dword ptr [edi+8*4]
	fld dword ptr [esi+6*4]
	fstp dword ptr [edi+9*4]
	fld dword ptr [esi+10*4]
	fchs
	fstp dword ptr [edi+10*4]
	fldz
	fstp dword ptr [edi+11*4]
	
	
	
	
	fld dword ptr [esi+12*4]
	fmul dword ptr [esi]
	fstp tmp
	fld dword ptr[esi+13*4]
	fmul dword ptr[esi+1*4]
	fadd tmp
	fstp tmp
	fld dword ptr[esi+14*4]
	fmul dword ptr[esi+2*4]
	fadd tmp
	fstp dword ptr [edi+12*4]
	
	fld dword ptr [esi+12*4]
	fmul dword ptr [esi+4*4]
	fstp tmp
	fld dword ptr[esi+13*4]
	fmul dword ptr[esi+5*4]
	fadd tmp
	fstp tmp
	fld dword ptr[esi+14*4]
	fmul dword ptr[esi+6*4]
	fadd tmp
	fstp dword ptr [edi+13*4]

	fld dword ptr [esi+12*4]
	fmul dword ptr [esi+8*4]
	fstp tmp
	fld dword ptr[esi+13*4]
	fmul dword ptr[esi+9*4]
	fadd tmp
	fstp tmp
	fld dword ptr[esi+14*4]
	fmul dword ptr[esi+10*4]
	fadd tmp
	fstp dword ptr [edi+14*4]
	
	fld1
	fstp dword ptr [edi+15*4]
	invoke glLoadMatrixf,addr v_mat
	
	ret
fSetView endp

fMovGlobal proc uses esi lpfX:dword,lpfY:dword,lpfZ:dword,lpfDistance:dword
	
	lea esi,mat_arr
	
	fld lpfX
	fmul lpfDistance
	fadd dword ptr[esi+12*4]
	fstp dword ptr[esi+12*4]
	
	fld lpfY
	fmul lpfDistance
	fadd dword ptr[esi+13*4]
	fstp dword ptr[esi+13*4]
	
	fld lpfZ
	fmul lpfDistance
	fadd dword ptr[esi+14*4]
	fstp dword ptr[esi+14*4]
	
	
	ret
fMovGlobal endp

fMovLoc proc uses esi lpfX:dword,lpfY:dword,lpfZ:dword,lpfDistance:dword
	LOCAL _dx,_dy,_dz:real4
	
	lea esi,mat_arr
 	fld dword ptr [esi]
 	fmul lpfX
 	fstp _dx
 	fld dword ptr [esi+4*4]
 	fmul lpfY
 	fadd _dx
 	fstp _dx
 	fld dword ptr [esi+8*4]
 	fmul lpfZ
 	fadd _dx
 	fstp _dx
 	
 	fld dword ptr [esi+1*4]
 	fmul lpfX
 	fstp _dy
 	fld dword ptr [esi+5*4]
 	fmul lpfY
 	fadd _dy
 	fstp _dy
 	fld dword ptr [esi+9*4]
 	fmul lpfZ
 	fadd _dy
 	fstp _dy
 	
 	fld dword ptr [esi+2*4]
 	fmul lpfX
 	fstp _dz
 	fld dword ptr [esi+6*4]
 	fmul lpfY
 	fadd _dz
 	fstp _dz
 	fld dword ptr [esi+10*4]
 	fmul lpfZ
 	fadd _dz
 	fstp _dz
 	
 	fld _dx
 	fmul lpfDistance
 	fadd dword ptr [esi+12*4]
 	fstp dword ptr [esi+12*4]
 	
 	fld _dy
 	fmul lpfDistance
 	fadd dword ptr [esi+13*4]
 	fstp dword ptr [esi+13*4]
 	
 	fld _dz
 	fmul lpfDistance
 	fadd dword ptr [esi+14*4]
 	fstp dword ptr [esi+14*4]

	
	ret
fMovLoc endp

fRotateLoc proc uses esi lpDegree:dword,lpfX:dword,lpfY:dword,lpfZ:dword
	
	invoke glMatrixMode,GL_MODELVIEW
	invoke glPushMatrix
	invoke glLoadMatrixf,addr mat_arr
	invoke glRotatef,lpDegree,lpfX,lpfY,lpfZ
	invoke glGetFloatv,GL_MODELVIEW_MATRIX,addr mat_arr
	invoke glPopMatrix
	
	ret
fRotateLoc endp

fRotateGlobal proc uses esi lpDegree:dword,lpfX:dword,lpfY:dword,lpfZ:dword
 	LOCAL _dx:real4
 	LOCAL _dy:real4
 	LOCAL _dz:real4
 	
 	lea esi,mat_arr
 	fld dword ptr [esi]
 	fmul lpfX
 	fstp _dx
 	fld dword ptr [esi+1*4]
 	fmul lpfY
 	fadd _dx
 	fstp _dx
 	fld dword ptr [esi+2*4]
 	fmul lpfZ
 	fadd _dx
 	fstp _dx
 	
 	fld dword ptr [esi+4*4]
 	fmul lpfX
 	fstp _dy
 	fld dword ptr [esi+5*4]
 	fmul lpfY
 	fadd _dy
 	fstp _dy
 	fld dword ptr [esi+6*4]
 	fmul lpfZ
 	fadd _dy
 	fstp _dy
 	
 	fld dword ptr [esi+8*4]
 	fmul lpfX
 	fstp _dz
 	fld dword ptr [esi+9*4]
 	fmul lpfY
 	fadd _dz
 	fstp _dz
 	fld dword ptr [esi+10*4]
 	fmul lpfZ
 	fadd _dz
 	fstp _dz
 	
 	invoke glMatrixMode,GL_MODELVIEW
 	invoke glPushMatrix
 	invoke glLoadMatrixf,esi
 ;	lea ecx,_dx
 ;	lea edx,_dy
 ;	lea eax,_dz
 	invoke glRotatef,lpDegree, _dx, _dy, _dz
 	invoke glGetFloatv,GL_MODELVIEW_MATRIX,addr mat_arr
 	invoke glPopMatrix
	
	ret
fRotateGlobal endp
;----------------------------------------------------------------------------------------------------

fFillMatrix4f proc uses esi lpfMat4:dword,nIndex:dword,lpValueReal4:dword
	
	mov esi,lpfMat4
	mov ecx,nIndex
	mov eax,lpValueReal4
	mov eax,[eax]
	mov [esi+ecx*4],eax
	
	ret
fFillMatrix4f endp

fGetMatrix4f proc uses esi lpfMat4:dword,nIndex:dword
	
	mov esi,lpfMat4
	mov ecx,nIndex
	mov eax,[esi+ecx*4]
	
	ret
fGetMatrix4f endp

nwGlobalRotation proc uses esi edi ebx lpfMat4X:dword,lpfMat4Y:dword,lpfMat4Z:dword,lpLength:dword
	;Originally created by NightWare at www.masmforum.com
	
	; eax = OFFSET of X rotation matrix ) must be 4*4 matrix (even if we only use 3*3)
	; ebx = OFFSET of Y rotation matrix )
	; ecx = OFFSET of Z rotation matrix )
	; edx = OFFSET of the point to calc
	movaps XMM0,OWORD PTR [ecx]
	movaps XMM1,OWORD PTR [ecx+4*DWORD]
	movaps XMM2,OWORD PTR [ecx+8*DWORD]
	movaps XMM5,OWORD PTR [eax]
	movaps XMM6,OWORD PTR [eax+4*DWORD]
	movaps XMM7,OWORD PTR [ecx+8*DWORD]
	movaps XMM3,XMM0
	movaps XMM4,XMM0
	shufps XMM0,XMM0,0C0h
	shufps XMM3,XMM3,0D5h
	shufps XMM4,XMM4,0EAh
	mulps XMM0,XMM5
	mulps XMM3,XMM6
	mulps XMM4,XMM7
	addps XMM0,XMM3
	addps XMM0,XMM4
	movaps XMM3,XMM1
	movaps XMM4,XMM1
	shufps XMM1,XMM1,0C0h
	shufps XMM3,XMM3,0D5h
	shufps XMM4,XMM4,0EAh
	mulps XMM1,XMM5
	mulps XMM3,XMM6
	mulps XMM4,XMM7
	addps XMM1,XMM3
	addps XMM1,XMM4
	movaps XMM3,XMM2
	movaps XMM4,XMM2
	shufps XMM2,XMM2,0C0h
	shufps XMM3,XMM3,0D5h
	shufps XMM4,XMM4,0EAh
	mulps XMM2,XMM5
	mulps XMM3,XMM6
	mulps XMM4,XMM7
	addps XMM2,XMM3
	addps XMM2,XMM4
	movaps XMM6,OWORD PTR [ebx]
	movaps XMM7,OWORD PTR [ebx+4*DWORD]
	movaps XMM5,OWORD PTR [ebx+8*DWORD]
	movaps XMM3,XMM6
	movaps XMM4,XMM6
	shufps XMM6,XMM6,0C0h
	shufps XMM3,XMM3,0D5h
	shufps XMM4,XMM4,0EAh
	mulps XMM6,XMM0
	mulps XMM3,XMM1
	mulps XMM4,XMM2
	addps XMM6,XMM3
	addps XMM6,XMM4
	movaps XMM3,XMM7
	movaps XMM4,XMM7
	shufps XMM7,XMM7,0C0h
	shufps XMM3,XMM3,0D5h
	shufps XMM4,XMM4,0EAh
	mulps XMM7,XMM0
	mulps XMM3,XMM1
	mulps XMM4,XMM2
	addps XMM7,XMM3
	addps XMM7,XMM4
	movaps XMM3,XMM5
	movaps XMM4,XMM5
	shufps XMM5,XMM5,0C0h
	shufps XMM3,XMM3,0D5h
	shufps XMM4,XMM4,0EAh
	mulps XMM5,XMM0
	mulps XMM3,XMM1
	mulps XMM4,XMM2
	addps XMM4,XMM5
	addps XMM4,XMM3
	; here, the global rotation matrix is in XMM6, XMM7 and XMM4
	
	
	;
	; here, we transpose the global rotation matrix (in XMM6, XMM7 et XMM4) to increase speed calc after...
	;
	movaps XMM5,XMM6
	movlhps XMM5,XMM7
	movhlps XMM7,XMM6
	movaps XMM6,XMM5
	shufps XMM5,XMM4,0C8h
	shufps XMM6,XMM4,0DDh
	shufps XMM7,XMM4,0E8h
	; here, the global rotation matrix is in XMM5, XMM6 and XMM7
	
	
	;
	; here, we calc a simple point (with our matrix in XMM5, XMM6 and XMM7)
	; after the global matrix is calculated, you just need to repeat this operation for every points
	;
	movaps XMM0,OWORD PTR [edx]
	movaps XMM1,XMM0
	movaps XMM2,XMM0
	shufps XMM0,XMM0,000h
	shufps XMM1,XMM1,055h
	shufps XMM2,XMM2,0AAh
	mulps XMM0,XMM5
	mulps XMM1,XMM6
	mulps XMM2,XMM7
	addps XMM0,XMM1
	addps XMM0,XMM2
	; here, XMM0 = _,newZ,newY,newX
	
	ret
nwGlobalRotation endp

fEnableOpenGL proc uses esi edi hWnd:dword,lphDC:dword,lpwRC:dword
	LOCAL pfd:PIXELFORMATDESCRIPTOR
	LOCAL iFormat:dword
	
	invoke memfill,addr pfd,sizeof 	PIXELFORMATDESCRIPTOR,0
	
	invoke GetDC,hWnd
	mov esi,lphDC
	push eax
	pop [esi]
	mov edi,lpwRC
	mov pfd.nSize,sizeof PIXELFORMATDESCRIPTOR
	mov pfd.nVersion,1
	mov pfd.dwFlags, PFD_DRAW_TO_WINDOW or PFD_SUPPORT_OPENGL or PFD_DOUBLEBUFFER 
	mov pfd.iPixelType,PFD_TYPE_RGBA
	mov pfd.cColorBits,24
	mov pfd.cDepthBits,16
	mov pfd.iLayerType,PFD_MAIN_PLANE
	
	invoke ChoosePixelFormat,[esi],addr pfd
	.if eax==0
		invoke MessageBox,hWnd,CADD("Failed at ChoosePixelFormat Function"),0,0
		ret
	.endif
	mov iFormat,eax
	invoke SetPixelFormat,[esi],iFormat,addr pfd
	.if eax==FALSE
		invoke MessageBox,hWnd,CADD("Failed at SetPixelFormat Function"),0,0
		ret
	.endif
	
	invoke wglCreateContext,[esi]
	.if eax==0
		invoke MessageBox,hWnd,CADD("Failed at wglCreateContext Function"),0,0
		ret
	.endif
	push eax
	pop [edi]
	
	invoke wglMakeCurrent,[esi],[edi]
	.if eax==FALSE
		invoke MessageBox,hWnd,CADD("Failed at wglMakeCurrent Function"),0,0
		ret
	.endif
	
	ret
fEnableOpenGL endp

fEnableOpenGLBitmap proc uses esi edi hWnd:dword,lphDC:dword,lpwRC:dword
	LOCAL pfd:PIXELFORMATDESCRIPTOR
	LOCAL iFormat:dword
	
	invoke memfill,addr pfd,sizeof 	PIXELFORMATDESCRIPTOR,0
	
	invoke GetDC,hWnd
	mov esi,lphDC
	push eax
	pop [esi]
	mov edi,lpwRC
	mov pfd.nSize,sizeof PIXELFORMATDESCRIPTOR
	mov pfd.nVersion,1
	mov pfd.dwFlags, PFD_SUPPORT_OPENGL or PFD_SUPPORT_GDI or PFD_DRAW_TO_BITMAP
	mov pfd.iPixelType,PFD_TYPE_RGBA
	mov pfd.cColorBits,24
	mov pfd.cDepthBits,16
	mov pfd.iLayerType,PFD_MAIN_PLANE
	
	invoke ChoosePixelFormat,[esi],addr pfd
	.if eax==0
		invoke MessageBox,hWnd,CADD("Failed at ChoosePixelFormat Function"),0,0
		ret
	.endif
	mov iFormat,eax
	invoke SetPixelFormat,[esi],iFormat,addr pfd
	.if eax==FALSE
		invoke MessageBox,hWnd,CADD("Failed at SetPixelFormat Function"),0,0
		ret
	.endif
	
	invoke wglCreateContext,[esi]
	.if eax==0
		invoke MessageBox,hWnd,CADD("Failed at wglCreateContext Function"),0,0
		ret
	.endif
	push eax
	pop [edi]
	
	invoke wglMakeCurrent,[esi],[edi]
	.if eax==FALSE
		invoke MessageBox,hWnd,CADD("Failed at wglMakeCurrent Function"),0,0
		ret
	.endif
	
	ret
fEnableOpenGLBitmap endp

fDisableOpenGL proc uses esi edi hWnd:dword,lphDC:dword,lpwRC:dword
	
	invoke wglMakeCurrent,0,0
	mov edx,lpwRC
	invoke wglDeleteContext,[edx]
	ret
fDisableOpenGL endp

fDrawTri proc uses esi edi lpfTri:dword,nFlag:dword
	LOCAL nIndex:dword
	LOCAL texture:dword
	
	mov esi,lpfTri
	
	
	
	invoke glEnable,GL_TEXTURE_2D
	invoke glBindTexture,GL_TEXTURE_2D,[esi].fTri.TexID
	
	;jmp @f
	xor ecx,ecx
	loop_each_vertex:
	pushad
		inc ecx
		mov nIndex,ecx
		invoke glBegin,nFlag
			invoke fTriGetVertexData,lpfTri,nIndex
			push eax
			invoke glNormal3f,[eax].fTriData.NormalX,[eax].fTriData.NormalY,[eax].fTriData.NormalZ
			pop eax
			push eax
			invoke glTexCoord2f,[eax].fTriData.U,[eax].fTriData.V
			pop eax
			push eax
			invoke glVertex3f,[eax].fTriData.PositionX,[eax].fTriData.PositionY,[eax].fTriData.PositionZ
			pop eax
			
			mov ecx,nIndex
			add ecx,1
			invoke fTriGetVertexData,lpfTri,ecx
			push eax
			invoke glNormal3f,[eax].fTriData.NormalX,[eax].fTriData.NormalY,[eax].fTriData.NormalZ
			pop eax
			push eax
			invoke glTexCoord2f,[eax].fTriData.U,[eax].fTriData.V
			pop eax
			push eax
			invoke glVertex3f,[eax].fTriData.PositionX,[eax].fTriData.PositionY,[eax].fTriData.PositionZ
			pop eax
			
			mov ecx,nIndex
			add ecx,2
			invoke fTriGetVertexData,lpfTri,ecx
			push eax
			invoke glNormal3f,[eax].fTriData.NormalX,[eax].fTriData.NormalY,[eax].fTriData.NormalZ
			pop eax
			push eax
			invoke glTexCoord2f,[eax].fTriData.U,[eax].fTriData.V
			pop eax
			push eax
			invoke glVertex3f,[eax].fTriData.PositionX,[eax].fTriData.PositionY,[eax].fTriData.PositionZ
			pop eax
			
		invoke glEnd
	popad
	add ecx,3
	cmp ecx,[esi].fTri.nVertex
	jl loop_each_vertex
	@@:
	
;	invoke glBegin,GL_QUADS
;		invoke glTexCoord2f,CFLT(0.0),CFLT(0.0)
;		invoke glVertex2f,CFLT(-1.0),CFLT(-1.0)
;		invoke glTexCoord2f,CFLT(1.0),CFLT(0.0)
;		invoke glVertex2f,CFLT(1.0),CFLT(-1.0)
;		invoke glTexCoord2f,CFLT(1.0),CFLT(1.0)
;		invoke glVertex2f,CFLT(1.0),CFLT(1.0)
;		invoke glTexCoord2f,CFLT(0.0),CFLT(1.0)
;		invoke glVertex2f,CFLT(-1.0),CFLT(1.0)
;	invoke glEnd
	
	invoke glBindTexture,GL_TEXTURE_2D,0
	
	ret
fDrawTri endp